package ru.amse.javadependencies.zhukova.data.dependencies.impl;

import ru.amse.javadependencies.zhukova.data.IJavaElement;
import ru.amse.javadependencies.zhukova.data.dependencies.IDependencyGraph;

import java.util.*;

/**
 * @author Anna R. Zhukova
 */
public class DependencyGraph<N extends IJavaElement> implements IDependencyGraph<N> {
    private final Map<String, N> myNameToClient = new HashMap<String, N>();
    private final Set<N> myClients = new HashSet<N>();

    public boolean addClient(N client) {
        return myClients.add(client);
    }

    public N getClient(String name) {
        return myNameToClient.get(name);
    }

    public Set<N> getClients() {
        return myClients;
    }

    public Collection<N> getAllClients() {
        return myNameToClient.values();
    }

    public String toString() {
        StringBuilder sb = new StringBuilder("{\n");
        int i = 0;
        for (N client : getClients()) {
            sb.append(++i);
            sb.append(") \n");
            sb.append(client.toString());
        }
        sb.append("}");
        return sb.toString();
    }

    public void put(String fullName, N clazz) {
        myNameToClient.put(fullName, clazz);
    }
}
