package ru.amse.javadependencies.zhukova.data.impl;

import ru.amse.javadependencies.zhukova.data.IClass;
import ru.amse.javadependencies.zhukova.data.IPackage;

import java.util.Set;
import java.util.HashSet;

/**
 * @author Anna R. Zhukova
 */
public class Package extends JavaElement implements IPackage {
    private Set<IClass> myClasses;

    public Package() {
        super();
    }

    public Package(String name, Set<IClass> classes) {
        super(name);
        myClasses = classes;
    }

    public Package(String name) {
        this(name, new HashSet<IClass>());
    }

    public boolean addClass(IClass _class) {
        return myClasses.add(_class);
    }

    public Set<IClass> getClasses() {
        return myClasses;
    }

    public String getFullName() {
        return getName();
    }
}
