package ru.amse.javadependencies.zhukova.model.impl;

import ru.amse.javadependencies.zhukova.model.IArcFilter;

import java.util.Set;
import java.util.HashSet;
import java.util.Collections;

/**
 * @author Anna R. Zhukova
 */
public class ArcFilter implements IArcFilter {
    private final Set<String> myBarriers = new HashSet<String>();

    public void init() {
        myBarriers.add("Type feature dependency");
        myBarriers.add("Element feature dependency");
        myBarriers.add("Type feature dependency: EXTENDING_DEPENDENCY");
        myBarriers.add("Type feature dependency: FIELD_DEPENDENCY");
        myBarriers.add("Type feature dependency: METHOD_ARGUMENT_DEPENDENCY");
        myBarriers.add("Type feature dependency: METHOD_RETURN_TYPE_DEPENDENCY");
        myBarriers.add("Type feature dependency: LOCAL_VARIABLE_DEPENDENCY");

    }

    public boolean accept(String s) {
        for (String barrier : myBarriers) {
            if (s.startsWith(barrier)) {
                return false;
            }
        }
        return true;
    }

    public boolean addBarrier(String s) {
        return myBarriers.add(s);
    }

    public boolean removeBarrier(String s) {
        return myBarriers.remove(s);
    }

    public void removeAllBarriers() {
        myBarriers.clear();
    }

    public Set<String> getBarriers() {
        return Collections.unmodifiableSet(myBarriers);
    }

    public boolean isABarrier(String s) {
        return myBarriers.contains(s);
    }
}
