package ru.amse.javadependencies.zhukova.ui.graphpane.tools;

import ru.amse.javadependencies.zhukova.ui.graphpane.GraphPane;
import ru.amse.javadependencies.zhukova.ui.undo.IUndoManager;

import java.awt.event.MouseAdapter;
import java.awt.*;

/**
 * @author Anna R. Zhukova
 */
public abstract class Tool extends MouseAdapter implements ITool {
    private static GraphPane ourGraphPane;
    private static IUndoManager ourUndoManager;

    public static void setGraphModel(GraphPane graphPane, IUndoManager undoManager) {
        ourGraphPane = graphPane;
        ourUndoManager = undoManager;
    }

    /*package*/ static GraphPane getGraphPane() {
        return ourGraphPane;
    }

    /*package*/ static IUndoManager getUndoManager() {
        return ourUndoManager;
    }

    public abstract void paint(Graphics g);
}
